#!/usr/bin/perl
use strict;
use LWP::Simple;
use Digest::MD5 qw(md5_hex);

# get server type
open(VPN, "</etc/sysconfig/vpn");
my $stype = 'fonality';
while(<VPN>) {

	if(/^GW.*trixbox/) {
		$stype = 'trixbox';
		last;
	}
}
close(VPN);

# get server id
open(CONF, "</etc/asterisk/fonality/globals.conf") || die "Can't open globals.conf for reading: $!";
my $srv;
while(<CONF>) {

	if(/^ACCOUNT=(.*)$/) {
		$srv = $1;
		last;
	}
}
close(CONF);

# get extension and new password
my $context = $ARGV[0];
my $ext     = $ARGV[1];
my $pswd    = $ARGV[2];

if ($context =~ /-(\d+)$/)
{
	$srv = $1;
}

my ($user, $auth) = get_auth();

my $url = "http://cp.$stype.com/vm_update_by_ext.cgi?server=$srv&ext=$ext&pswd=$pswd&user=$user&hash=$auth";
print STDERR "vm password change: stype: $stype, server: $srv, ext: $ext, pswd: $pswd\n";
print STDERR "calling $url\n\n";

get($url);

sub get_auth
{
	my ($user, $pass) = ('', '');

	open my $globals, '<', '/etc/asterisk/fonality/globals.conf' || return($user, $pass);
	while (my $line = <$globals>)
	{
		if ($line =~ /^IAXINFO/)
		{
			if ($line =~ /IAXINFO\d?=(s\d+):([^;\s]+)/)
			{
				($user, $pass) = ($1, Digest::MD5::md5_hex($2));
				$user =~ s/[xi]$//;
			}
			last;
		}
	}

	close $globals;
	return($user, $pass);
}
